﻿--[[---------------------------------------------------------------------------

Copyright (c) 2008 by K. Scott Piel 
All Rights Reserved

E-mail: < kscottpiel@gmail.com >
Web:    < http://www.scottpiel.com >

This file is part of nUI.

    nUI is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    nUI is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with nUI.  If not, see <http://www.gnu.org/licenses/>.
	
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE 
USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

--]]---------------------------------------------------------------------------
	
-------------------------------------------------------------------------------
-- default layout values

nUI_ButtonLayout =
{
	height     = 30,		-- the vertical size of the button
	width      = 30,		-- the horizontal size of the button
	show_grid  = "no",		-- whether or not to display the button grid: yes|no
	binding_id = "",		-- the key binding name assigned to this button
	hotkeys    = "yes",		-- whether or not to display hotkey text on the button: yes|no
	counts     = "yes",		-- whether or not to display stack counts on the button: yes|no
	btn_type   = nil,		-- the type of button as per GetBindingKey
	button     = nil,		-- the name of the button object we are attaching to
	inherits   = nil,		-- what button type template we'll inherit, if any
	id         = nil,		-- if the button has an assigned ID (a la ActionBarButton)
}

nUI.Class.ButtonLayout = nUI.Class:CreatePrototype();
local prototype        = nUI.Class.ButtonLayout.prototype;

-------------------------------------------------------------------------------
-- this may look a little like a PITA, but it makes it possible to add new values
-- at any time without having to parse the existing user config and insert, etc.

function prototype:init( user_defined )
	
	if not user_defined then user_defined = {}; end
	
	self.height      = tonumber( user_defined.height or nUI_ButtonLayout.height );
	self.width       = tonumber( user_defined.width or nUI_ButtonLayout.width );
	self.show_grid   = strlower( user_defined.show_grid or nUI_ButtonLayout.show_grid );
	self.binding_id  = strupper( user_defined.binding_id or nUI_ButtonLayout.binding_id );
	self.hotkeys     = strlower( user_defined.hotkeys or nUI_ButtonLayout.hotkeys );
	self.counts      = strlower( user_defined.counts or nUI_ButtonLayout.counts );
	self.btn_type    = user_defined.btn_type or nUI_ButtonLayout.btn_type;
	self.button      = user_defined.button or nUI_ButtonLayout.button;
	self.inherits    = user_defined.inherits or nUI_ButtonLayout.inherits;
	self.id          = user_defined.id or nUI_ButtonLayout.id;
	
end	
